updateState = function() {
    $.ajax({
        url: "v1/state",
        success: function(result) {
            if (result.success == true){
                result.services.forEach(function(item){
                    itemHtml = "";
                    if (!item.isRunning && !item.inAutostart){
                        itemHtml = '<i class="glyphicon glyphicon-remove" style="color:grey"/> не установлен';
                    }else if(item.isRunning && !item.inAutostart){
                        itemHtml = '<i class="glyphicon glyphicon-ok" style="color:grey"/> запущен без установки';
                    }else if(!item.isRunning && item.inAutostart){
                        itemHtml = '<i class="glyphicon glyphicon-repeat spinning" style="color:red"/> не запущен. Подождите...';
                    }else if(item.isRunning && item.inAutostart){
                        itemHtml = '<i class="glyphicon glyphicon-ok" style="color:green"/> запущен';
                    }
                    $("#"+item.id+"_state").html(itemHtml);
                });
            }
        }
    });
}

updateStateInRound = function() {
    updateState();
    setInterval(function() {updateState();}, 10000);
}

getDocHeight = function() {
    var D = document;
    return Math.max(
        D.body.scrollHeight, D.documentElement.scrollHeight,
        D.body.offsetHeight, D.documentElement.offsetHeight,
        D.body.clientHeight, D.documentElement.clientHeight
    );
}

updateLogsOnState = function(service, state) {
    var scrollToBottom = false;
    if(state.beginIndex != state.endIndex){
        if($(window).scrollTop() + $(window).height() == $(document).height()) {
            scrollToBottom = true;
        }
        $.ajax({
            url: "/v1/logs/" + service + "/part/begin/" + state.beginIndex + "/end/" + state.endIndex,
            success: function(result) {
                $("#logs_body").append("<pre>" + result + "</pre>")
                state.beginIndex = state.endIndex;
                if (scrollToBottom){
                    $(window).scrollTop($(document).height());
                }
            }
        });
    }
}
readLogs = function(service) {
    this.state = {};
    state.beginIndex = 0;
    setInterval(function() {
        $.ajax({
            url: "/v1/logs/" + service + "/size",
            success: function(result) {
                state.endIndex = result.size;
                if (state.beginIndex == 0 && state.endIndex > 10000) {
                    state.beginIndex = state.endIndex - 10000;
                };
                updateLogsOnState(service, state);
            }
        });
    }, 1000);
}
